#ifndef __XC8M9003_H__
#define __XC8M9003_H__

//
// Register addresses.
//
//RPAGE Bank0
#define RSR_ADDR         	0X80
#define PCH_ADDR         	0X81
#define PCL_ADDR          	0X82
#define STATUS_ADDR        	0X83
#define TC0CON_ADDR         0X84
#define TC0C_ADDR         	0X85
#define TBRDH_ADDR        	0X86
#define TBRDL_ADDR        	0X87
#define CPUCON_ADDR        	0X88
#define IRCCAL_ADDR        	0X89
#define PORT5_ADDR        	0X8A
#define PORT6_ADDR        	0X8B
#define PORT7_ADDR        	0X8C
#define P5CR_ADDR        	0X8D
#define P6CR_ADDR        	0X8E
#define P7CR_ADDR        	0X8F

#define P5PHCR_ADDR        	0X90
#define P6PHCR_ADDR        	0X91
#define P7PHCR_ADDR        	0X92
#define P5PDCR_ADDR        	0X93
#define P6PDCR_ADDR        	0X94
#define P7PDCR_ADDR        	0X95
#define P6ODCR_ADDR        	0X96
#define P5IWE_ADDR        	0X97
#define P6IWE_ADDR        	0X98
#define P7IWE_ADDR        	0X99
#define P5HDCR_ADDR        	0X9A
#define P6HDCR_ADDR        	0X9B
#define P7HDCR_ADDR        	0X9C
#define P5HSCR_ADDR        	0X9D
#define P6HSCR_ADDR        	0X9E
#define P7HSCR_ADDR        	0X9F

#define P5ADE_ADDR         	0XA0
#define P6ADE_ADDR         	0XA1
#define P7ADE_ADDR         	0XA2
#define ADDATA_ADDR        	0XA3
#define ADDATA1H_ADDR      	0XA4
#define ADDATA1L_ADDR      	0XA5
#define ADIGS_ADDR        	0XA6
#define ADOC_ADDR        	0XA7
#define ADCON_ADDR        	0XA8
#define ADCMP_ADDR        	0XAD
#define LVDCON_ADDR        	0XAE
#define WDTCON_ADDR        	0XAF

#define PWM0CON_ADDR       	0XB0
#define PWM0RD_ADDR         0XB1
#define PWM0DT_ADDR         0XB2
#define TMR0_ADDR         	0XB3
#define PWM1CON_ADDR        0XB4
#define PWM1RD_ADDR         0XB5
#define PWM1DT_ADDR        	0XB6
#define TMR1_ADDR        	0XB7
#define PWM2CON_ADDR        0XB8
#define PWM2RD_ADDR        	0XB9
#define PWM2DT_ADDR        	0XBA
#define TMR2_ADDR        	0XBB
#define PWM3CON_ADDR        0XBC
#define PWM3RD_ADDR        	0XBD
#define PWM3DT_ADDR        	0XBE
#define TMR3_ADDR        	0XBF

#define PWMCS_ADDR         	0XC9
#define PWMDEADT_ADDR       0XCA
#define PWMIS1_ADDR         0XCB
#define PWMIS2_ADDR         0XCC

#define TC1CON_ADDR			0XD0	
#define TC1H_ADDR         	0XD1
#define TC1L_ADDR          	0XD2
#define EINTR_ADDR         	0XD5
#define IMR1_ADDR         	0XD6
#define IMR2_ADDR         	0XD7
#define ISR1_ADDR        	0XDA
#define ISR2_ADDR        	0XDB
#define WECR_ADDR        	0XDE

#define EEPCON_ADDR			0XE0
#define EEPDAT_ADDR			0XE1	
#define IAR_ADDR          	0XFF  

//
//----- Register Files -----------------------------------------------------
//
extern __sfr __at (RSR_ADDR)        	RSR;         	
extern __sfr __at (PCH_ADDR)        	PCH;         	
extern __sfr __at (PCL_ADDR)        	PCL;          	
extern __sfr __at (STATUS_ADDR)        	STATUS;         	
extern __sfr __at (TC0CON_ADDR)        	TC0CON;         	
extern __sfr __at (TC0C_ADDR)        	TC0C;         	
extern __sfr __at (TBRDH_ADDR)       	TBRDH;        	
extern __sfr __at (TBRDL_ADDR)       	TBRDL;        	
extern __sfr __at (CPUCON_ADDR)       	CPUCON;        	
extern __sfr __at (IRCCAL_ADDR)       	IRCCAL;        	
extern __sfr __at (PORT5_ADDR)       	PORT5;        	
extern __sfr __at (PORT6_ADDR)       	PORT6;        	
extern __sfr __at (PORT7_ADDR)       	PORT7;        	
extern __sfr __at (P5CR_ADDR)       	P5CR;        	
extern __sfr __at (P6CR_ADDR)       	P6CR;        	
extern __sfr __at (P7CR_ADDR)       	P7CR;   

extern __sfr __at (P5PHCR_ADDR)    	P5PHCR;         	
extern __sfr __at (P6PHCR_ADDR)    	P6PHCR;         	
extern __sfr __at (P7PHCR_ADDR)        	P7PHCR;          	
extern __sfr __at (P5PDCR_ADDR)        	P5PDCR;         	
extern __sfr __at (P6PDCR_ADDR)        	P6PDCR;         	
extern __sfr __at (P7PDCR_ADDR)        	P7PDCR;         	
extern __sfr __at (P6ODCR_ADDR)       	P6ODCR;        	
extern __sfr __at (P5IWE_ADDR)       	P5IWE;        	
extern __sfr __at (P6IWE_ADDR)       	P6IWE;        	
extern __sfr __at (P7IWE_ADDR)       	P7IWE;        	
extern __sfr __at (P5HDCR_ADDR)       	P5HDCR;        	
extern __sfr __at (P6HDCR_ADDR)       	P6HDCR;        	
extern __sfr __at (P7HDCR_ADDR)       	P7HDCR;        	
extern __sfr __at (P5HSCR_ADDR)       	P5HSCR;        	
extern __sfr __at (P6HSCR_ADDR)       	P6HSCR;        	
extern __sfr __at (P7HSCR_ADDR)       	P7HSCR; 

extern __sfr __at (P5ADE_ADDR)    	P5ADE;         	
extern __sfr __at (P6ADE_ADDR)    	P6ADE;         	
extern __sfr __at (P7ADE_ADDR)        	P7ADE;          	
extern __sfr __at (ADDATA_ADDR)        	ADDATA;         	
extern __sfr __at (ADDATA1H_ADDR)       ADDATA1H;         	
extern __sfr __at (ADDATA1L_ADDR)       ADDATA1L;         	
extern __sfr __at (ADIGS_ADDR)       	ADIGS;        	
extern __sfr __at (ADOC_ADDR)       	ADOC;        	
extern __sfr __at (ADCON_ADDR)       	ADCON;        	
extern __sfr __at (ADCMP_ADDR)       	ADCMP;        	
extern __sfr __at (LVDCON_ADDR)       	LVDCON;        	
extern __sfr __at (WDTCON_ADDR)       	WDTCON;        	
 
extern __sfr __at (PWM0CON_ADDR)    	PWM0CON;         	
extern __sfr __at (PWM0RD_ADDR)    	PWM0RD;         	
extern __sfr __at (PWM0DT_ADDR)        	PWM0DT;          	
extern __sfr __at (TMR0_ADDR)        	TMR0;         	
extern __sfr __at (PWM1CON_ADDR)        PWM1CON;         	
extern __sfr __at (PWM1RD_ADDR)        	PWM1RD;         	
extern __sfr __at (PWM1DT_ADDR)       	PWM1DT;        	
extern __sfr __at (TMR1_ADDR)       	TMR1;        	
extern __sfr __at (PWM2CON_ADDR)       	PWM2CON;        	
extern __sfr __at (PWM2RD_ADDR)       	PWM2RD;        	
extern __sfr __at (PWM2DT_ADDR)       	PWM2DT;        	
extern __sfr __at (TMR2_ADDR)       	TMR2;        	
extern __sfr __at (PWM3CON_ADDR)       	PWM3CON;        	
extern __sfr __at (PWM3RD_ADDR)       	PWM3RD;        	
extern __sfr __at (PWM3DT_ADDR)       	PWM3DT;        	
extern __sfr __at (TMR3_ADDR)       	TMR3;

extern __sfr __at (PWMCS_ADDR)    	PWMCS;         	
extern __sfr __at (PWMDEADT_ADDR)    	PWMDEADT;         	
extern __sfr __at (PWMIS1_ADDR)        	PWMIS1;          	
extern __sfr __at (PWMIS2_ADDR)        	PWMIS2;

extern __sfr __at (TC1CON_ADDR)    	TC1CON;         	
extern __sfr __at (TC1H_ADDR)    	TC1H;         	
extern __sfr __at (TC1L_ADDR)        	TC1L;          	
extern __sfr __at (EINTR_ADDR)        	EINTR;         	
extern __sfr __at (IMR1_ADDR)        	IMR1;         	
extern __sfr __at (IMR2_ADDR)        	IMR2;         	
extern __sfr __at (ISR1_ADDR)       	ISR1;        	       	
extern __sfr __at (ISR2_ADDR)       	ISR2;        	
extern __sfr __at (WECR_ADDR)       	WECR;  

extern __sfr __at (EEPCON_ADDR)       	EEPCON;        	       	
extern __sfr __at (EEPDAT_ADDR)       	EEPDAT;        	
extern __sfr __at (IAR_ADDR)       	IAR;        	
      	
//==========================================================================
//
//	Configuration Bits
//
//==========================================================================

// ----- FSR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char RSR_0:1;
		unsigned char RSR_1:1;
		unsigned char RSR_2:1;
		unsigned char RSR_3:1;	
		unsigned char RSR_4:1;
		unsigned char RSR_5:1;
		unsigned char RSR_6:1;
		unsigned char RSR_7:1;		
	};
} __RSRbits_t;
extern volatile __RSRbits_t __at(RSR_ADDR) RSRbits;

#define RSR_0         	RSRbits.RSR_0   	/* bit 0 */
#define RSR_1         	RSRbits.RSR_1     	/* bit 1 */
#define RSR_2         	RSRbits.RSR_2          	/* bit 2 */
#define RSR_3         	RSRbits.RSR_3          	/* bit 3 */
#define RSR_4         	RSRbits.RSR_4   	/* bit 4 */
#define RSR_5         	RSRbits.RSR_5     	/* bit 5 */
#define RSR_6         	RSRbits.RSR_6          	/* bit 6 */
#define RSR_7         	RSRbits.RSR_7          	/* bit 7 */

// ----- PCH Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PCH_0:1;
		unsigned char PCH_1:1;
		unsigned char PCH_2:1;
		unsigned char PCH_3:1;	
		unsigned char PCH_4:1;
		unsigned char PCH_5:1;
		unsigned char PCH_6:1;
		unsigned char PCH_7:1;		
	};
} __PCHbits_t;
extern volatile __PCHbits_t __at(PCH_ADDR) PCHbits;

#define PCH_0         	PCHbits.PCH_0   	/* bit 0 */
#define PCH_1         	PCHbits.PCH_1     	/* bit 1 */
#define PCH_2         	PCHbits.PCH_2          	/* bit 2 */
#define PCH_3         	PCHbits.PCH_3          	/* bit 3 */
#define PCH_4         	PCHbits.PCH_4   	/* bit 4 */
#define PCH_5         	PCHbits.PCH_5     	/* bit 5 */
#define PCH_6         	PCHbits.PCH_6          	/* bit 6 */
#define PCH_7         	PCHbits.PCH_7          	/* bit 7 */

// ----- PCL Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PCL_0:1;
		unsigned char PCL_1:1;
		unsigned char PCL_2:1;
		unsigned char PCL_3:1;	
		unsigned char PCL_4:1;
		unsigned char PCL_5:1;
		unsigned char PCL_6:1;
		unsigned char PCL_7:1;		
	};
} __PCLbits_t;
extern volatile __PCLbits_t __at(PCL_ADDR) PCLbits;

#define PCL_0         	PCLbits.PCL_0   	/* bit 0 */
#define PCL_1         	PCLbits.PCL_1     	/* bit 1 */
#define PCL_2         	PCLbits.PCL_2          	/* bit 2 */
#define PCL_3         	PCLbits.PCL_3          	/* bit 3 */
#define PCL_4         	PCLbits.PCL_4   	/* bit 4 */
#define PCL_5         	PCLbits.PCL_5     	/* bit 5 */
#define PCL_6         	PCLbits.PCL_6          	/* bit 6 */
#define PCL_7         	PCLbits.PCL_7          	/* bit 7 */

// ----- STATUS Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char STATUS_0:1;
		unsigned char STATUS_1:1;
		unsigned char STATUS_2:1;
		unsigned char STATUS_3:1;	
		unsigned char STATUS_4:1;
		unsigned char STATUS_5:1;
		unsigned char STATUS_6:1;
		unsigned char STATUS_7:1;		
	};
} __STATUSbits_t;
extern volatile __STATUSbits_t __at(STATUS_ADDR) STATUSbits;

#define STATUS_0         STATUSbits.STATUS_0   	/* bit 0 */
#define STATUS_1         STATUSbits.STATUS_1    /* bit 1 */
#define STATUS_2         STATUSbits.STATUS_2    /* bit 2 */
#define STATUS_3         STATUSbits.STATUS_3    /* bit 3 */
#define STATUS_4         STATUSbits.STATUS_4   	/* bit 4 */
#define STATUS_5         STATUSbits.STATUS_5    /* bit 5 */
#define STATUS_6         STATUSbits.STATUS_6    /* bit 6 */
#define STATUS_7         STATUSbits.STATUS_7    /* bit 7 */

// ----- TC0CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TC0CON_0:1;
		unsigned char TC0CON_1:1;
		unsigned char TC0CON_2:1;
		unsigned char TC0CON_3:1;	
		unsigned char TC0CON_4:1;
		unsigned char TC0CON_5:1;
		unsigned char TC0CON_6:1;
		unsigned char TC0CON_7:1;		
	};
} __TC0CONbits_t;
extern volatile __TC0CONbits_t __at(TC0CON_ADDR) TC0CONbits;

#define TC0CON_0         TC0CONbits.TC0CON_0   	/* bit 0 */
#define TC0CON_1         TC0CONbits.TC0CON_1    /* bit 1 */
#define TC0CON_2         TC0CONbits.TC0CON_2    /* bit 2 */
#define TC0CON_3         TC0CONbits.TC0CON_3    /* bit 3 */
#define TC0CON_4         TC0CONbits.TC0CON_4   	/* bit 4 */
#define TC0CON_5         TC0CONbits.TC0CON_5    /* bit 5 */
#define TC0CON_6         TC0CONbits.TC0CON_6    /* bit 6 */
#define TC0CON_7         TC0CONbits.TC0CON_7    /* bit 7 */

// ----- TC0C Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TC0C_0:1;
		unsigned char TC0C_1:1;
		unsigned char TC0C_2:1;
		unsigned char TC0C_3:1;	
		unsigned char TC0C_4:1;
		unsigned char TC0C_5:1;
		unsigned char TC0C_6:1;
		unsigned char TC0C_7:1;		
	};
} __TC0Cbits_t;
extern volatile __TC0Cbits_t __at(TC0C_ADDR) TC0Cbits;

#define TC0C_0         	TC0Cbits.TC0C_0   	/* bit 0 */
#define TC0C_1         	TC0Cbits.TC0C_1     	/* bit 1 */
#define TC0C_2         	TC0Cbits.TC0C_2         /* bit 2 */
#define TC0C_3         	TC0Cbits.TC0C_3         /* bit 3 */
#define TC0C_4         	TC0Cbits.TC0C_4   	/* bit 4 */
#define TC0C_5         	TC0Cbits.TC0C_5     	/* bit 5 */
#define TC0C_6         	TC0Cbits.TC0C_6         /* bit 6 */
#define TC0C_7         	TC0Cbits.TC0C_7         /* bit 7 */

// ----- TBRDH Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TBRDH_0:1;
		unsigned char TBRDH_1:1;
		unsigned char TBRDH_2:1;
		unsigned char TBRDH_3:1;	
		unsigned char TBRDH_4:1;
		unsigned char TBRDH_5:1;
		unsigned char TBRDH_6:1;
		unsigned char TBRDH_7:1;		
	};
} __TBRDHbits_t;
extern volatile __TBRDHbits_t __at(TBRDH_ADDR) TBRDHbits;

#define TBRDH_0         TBRDHbits.TBRDH_0   	/* bit 0 */
#define TBRDH_1         TBRDHbits.TBRDH_1     	/* bit 1 */
#define TBRDH_2         TBRDHbits.TBRDH_2       /* bit 2 */
#define TBRDH_3         TBRDHbits.TBRDH_3       /* bit 3 */
#define TBRDH_4         TBRDHbits.TBRDH_4   	/* bit 4 */
#define TBRDH_5         TBRDHbits.TBRDH_5     	/* bit 5 */
#define TBRDH_6         TBRDHbits.TBRDH_6       /* bit 6 */
#define TBRDH_7         TBRDHbits.TBRDH_7       /* bit 7 */

// ----- TBRDL Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TBRDL_0:1;
		unsigned char TBRDL_1:1;
		unsigned char TBRDL_2:1;
		unsigned char TBRDL_3:1;	
		unsigned char TBRDL_4:1;
		unsigned char TBRDL_5:1;
		unsigned char TBRDL_6:1;
		unsigned char TBRDL_7:1;		
	};
} __TBRDLbits_t;
extern volatile __TBRDLbits_t __at(TBRDL_ADDR) TBRDLbits;

#define TBRDL_0         TBRDLbits.TBRDL_0   	/* bit 0 */
#define TBRDL_1         TBRDLbits.TBRDL_1     	/* bit 1 */
#define TBRDL_2         TBRDLbits.TBRDL_2       /* bit 2 */
#define TBRDL_3         TBRDLbits.TBRDL_3       /* bit 3 */
#define TBRDL_4         TBRDLbits.TBRDL_4   	/* bit 4 */
#define TBRDL_5         TBRDLbits.TBRDL_5     	/* bit 5 */
#define TBRDL_6         TBRDLbits.TBRDL_6       /* bit 6 */
#define TBRDL_7         TBRDLbits.TBRDL_7       /* bit 7 */

// ----- CPUCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char CPUCON_0:1;
		unsigned char CPUCON_1:1;
		unsigned char CPUCON_2:1;
		unsigned char CPUCON_3:1;	
		unsigned char CPUCON_4:1;
		unsigned char CPUCON_5:1;
		unsigned char CPUCON_6:1;
		unsigned char CPUCON_7:1;		
	};
} __CPUCONbits_t;
extern volatile __CPUCONbits_t __at(CPUCON_ADDR) CPUCONbits;

#define CPUCON_0         CPUCONbits.CPUCON_0   	/* bit 0 */
#define CPUCON_1         CPUCONbits.CPUCON_1    /* bit 1 */
#define CPUCON_2         CPUCONbits.CPUCON_2    /* bit 2 */
#define CPUCON_3         CPUCONbits.CPUCON_3    /* bit 3 */
#define CPUCON_4         CPUCONbits.CPUCON_4   	/* bit 4 */
#define CPUCON_5         CPUCONbits.CPUCON_5    /* bit 5 */
#define CPUCON_6         CPUCONbits.CPUCON_6    /* bit 6 */
#define CPUCON_7         CPUCONbits.CPUCON_7    /* bit 7 */

// ----- IRCCAL Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char IRCCAL_0:1;
		unsigned char IRCCAL_1:1;
		unsigned char IRCCAL_2:1;
		unsigned char IRCCAL_3:1;	
		unsigned char IRCCAL_4:1;
		unsigned char IRCCAL_5:1;
		unsigned char IRCCAL_6:1;
		unsigned char IRCCAL_7:1;		
	};
} __IRCCALbits_t;
extern volatile __IRCCALbits_t __at(IRCCAL_ADDR) IRCCALbits;

#define IRCCAL_0         IRCCALbits.IRCCAL_0   	/* bit 0 */
#define IRCCAL_1         IRCCALbits.IRCCAL_1    /* bit 1 */
#define IRCCAL_2         IRCCALbits.IRCCAL_2    /* bit 2 */
#define IRCCAL_3         IRCCALbits.IRCCAL_3    /* bit 3 */
#define IRCCAL_4         IRCCALbits.IRCCAL_4   	/* bit 4 */
#define IRCCAL_5         IRCCALbits.IRCCAL_5    /* bit 5 */
#define IRCCAL_6         IRCCALbits.IRCCAL_6    /* bit 6 */
#define IRCCAL_7         IRCCALbits.IRCCAL_7    /* bit 7 */

// ----- PORT5 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PORT5_0:1;
		unsigned char PORT5_1:1;
		unsigned char PORT5_2:1;
		unsigned char PORT5_3:1;	
		unsigned char PORT5_4:1;
		unsigned char PORT5_5:1;
		unsigned char PORT5_6:1;
		unsigned char PORT5_7:1;		
	};
} __PORT5bits_t;
extern volatile __PORT5bits_t __at(PORT5_ADDR) PORT5bits;

#define PORT5_0         PORT5bits.PORT5_0   	/* bit 0 */
#define PORT5_1         PORT5bits.PORT5_1     	/* bit 1 */
#define PORT5_2         PORT5bits.PORT5_2       /* bit 2 */
#define PORT5_3         PORT5bits.PORT5_3       /* bit 3 */
#define PORT5_4         PORT5bits.PORT5_4   	/* bit 4 */
#define PORT5_5         PORT5bits.PORT5_5     	/* bit 5 */
#define PORT5_6         PORT5bits.PORT5_6       /* bit 6 */
#define PORT5_7         PORT5bits.PORT5_7       /* bit 7 */

// ----- PORT6 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PORT6_0:1;
		unsigned char PORT6_1:1;
		unsigned char PORT6_2:1;
		unsigned char PORT6_3:1;	
		unsigned char PORT6_4:1;
		unsigned char PORT6_5:1;
		unsigned char PORT6_6:1;
		unsigned char PORT6_7:1;		
	};
} __PORT6bits_t;
extern volatile __PORT6bits_t __at(PORT6_ADDR) PORT6bits;

#define PORT6_0         PORT6bits.PORT6_0   	/* bit 0 */
#define PORT6_1         PORT6bits.PORT6_1     	/* bit 1 */
#define PORT6_2         PORT6bits.PORT6_2       /* bit 2 */
#define PORT6_3         PORT6bits.PORT6_3       /* bit 3 */
#define PORT6_4         PORT6bits.PORT6_4   	/* bit 4 */
#define PORT6_5         PORT6bits.PORT6_5     	/* bit 5 */
#define PORT6_6         PORT6bits.PORT6_6       /* bit 6 */
#define PORT6_7         PORT6bits.PORT6_7       /* bit 7 */

// ----- PORT7 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PORT7_0:1;
		unsigned char PORT7_1:1;
		unsigned char PORT7_2:1;
		unsigned char PORT7_3:1;	
		unsigned char PORT7_4:1;
		unsigned char PORT7_5:1;
		unsigned char PORT7_6:1;
		unsigned char PORT7_7:1;		
	};
} __PORT7bits_t;
extern volatile __PORT7bits_t __at(PORT7_ADDR) PORT7bits;

#define PORT7_0         PORT7bits.PORT7_0   	/* bit 0 */
#define PORT7_1         PORT7bits.PORT7_1     	/* bit 1 */
#define PORT7_2         PORT7bits.PORT7_2       /* bit 2 */
#define PORT7_3         PORT7bits.PORT7_3       /* bit 3 */
#define PORT7_4         PORT7bits.PORT7_4   	/* bit 4 */
#define PORT7_5         PORT7bits.PORT7_5     	/* bit 5 */
#define PORT7_6         PORT7bits.PORT7_6       /* bit 6 */
#define PORT7_7         PORT7bits.PORT7_7       /* bit 7 */

// ----- P5CR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5CR_0:1;
		unsigned char P5CR_1:1;
		unsigned char P5CR_2:1;
		unsigned char P5CR_3:1;	
		unsigned char P5CR_4:1;
		unsigned char P5CR_5:1;
		unsigned char P5CR_6:1;
		unsigned char P5CR_7:1;		
	};
} __P5CRbits_t;
extern volatile __P5CRbits_t __at(P5CR_ADDR) P5CRbits;

#define P5CR_0         	P5CRbits.P5CR_0   	/* bit 0 */
#define P5CR_1         	P5CRbits.P5CR_1     	/* bit 1 */
#define P5CR_2         	P5CRbits.P5CR_2         /* bit 2 */
#define P5CR_3         	P5CRbits.P5CR_3         /* bit 3 */
#define P5CR_4         	P5CRbits.P5CR_4   	/* bit 4 */
#define P5CR_5         	P5CRbits.P5CR_5     	/* bit 5 */
#define P5CR_6         	P5CRbits.P5CR_6         /* bit 6 */
#define P5CR_7         	P5CRbits.P5CR_7         /* bit 7 */

// ----- P6CR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6CR_0:1;
		unsigned char P6CR_1:1;
		unsigned char P6CR_2:1;
		unsigned char P6CR_3:1;	
		unsigned char P6CR_4:1;
		unsigned char P6CR_5:1;
		unsigned char P6CR_6:1;
		unsigned char P6CR_7:1;		
	};
} __P6CRbits_t;
extern volatile __P6CRbits_t __at(P6CR_ADDR) P6CRbits;

#define P6CR_0         	P6CRbits.P6CR_0   	/* bit 0 */
#define P6CR_1         	P6CRbits.P6CR_1     	/* bit 1 */
#define P6CR_2         	P6CRbits.P6CR_2         /* bit 2 */
#define P6CR_3         	P6CRbits.P6CR_3         /* bit 3 */
#define P6CR_4         	P6CRbits.P6CR_4   	/* bit 4 */
#define P6CR_5         	P6CRbits.P6CR_5     	/* bit 5 */
#define P6CR_6         	P6CRbits.P6CR_6         /* bit 6 */
#define P6CR_7         	P6CRbits.P6CR_7         /* bit 7 */

// ----- P7CR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P7CR_0:1;
		unsigned char P7CR_1:1;
		unsigned char P7CR_2:1;
		unsigned char P7CR_3:1;	
		unsigned char P7CR_4:1;
		unsigned char P7CR_5:1;
		unsigned char P7CR_6:1;
		unsigned char P7CR_7:1;		
	};
} __P7CRbits_t;
extern volatile __P7CRbits_t __at(P7CR_ADDR) P7CRbits;

#define P7CR_0         	P7CRbits.P7CR_0   	/* bit 0 */
#define P7CR_1         	P7CRbits.P7CR_1     	/* bit 1 */
#define P7CR_2         	P7CRbits.P7CR_2         /* bit 2 */
#define P7CR_3         	P7CRbits.P7CR_3         /* bit 3 */
#define P7CR_4         	P7CRbits.P7CR_4   	/* bit 4 */
#define P7CR_5         	P7CRbits.P7CR_5     	/* bit 5 */
#define P7CR_6         	P7CRbits.P7CR_6         /* bit 6 */
#define P7CR_7         	P7CRbits.P7CR_7         /* bit 7 */

// ----- P5PHCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5PHCR_0:1;
		unsigned char P5PHCR_1:1;
		unsigned char P5PHCR_2:1;
		unsigned char P5PHCR_3:1;	
		unsigned char P5PHCR_4:1;
		unsigned char P5PHCR_5:1;
		unsigned char P5PHCR_6:1;
		unsigned char P5PHCR_7:1;		
	};
} __P5PHCRbits_t;
extern volatile __P5PHCRbits_t __at(P5PHCR_ADDR) P5PHCRbits;

#define P5PHCR_0         P5PHCRbits.P5PHCR_0   	/* bit 0 */
#define P5PHCR_1         P5PHCRbits.P5PHCR_1    /* bit 1 */
#define P5PHCR_2         P5PHCRbits.P5PHCR_2    /* bit 2 */
#define P5PHCR_3         P5PHCRbits.P5PHCR_3    /* bit 3 */
#define P5PHCR_4         P5PHCRbits.P5PHCR_4   	/* bit 4 */
#define P5PHCR_5         P5PHCRbits.P5PHCR_5    /* bit 5 */
#define P5PHCR_6         P5PHCRbits.P5PHCR_6    /* bit 6 */
#define P5PHCR_7         P5PHCRbits.P5PHCR_7    /* bit 7 */

// ----- P6PHCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6PHCR_0:1;
		unsigned char P6PHCR_1:1;
		unsigned char P6PHCR_2:1;
		unsigned char P6PHCR_3:1;	
		unsigned char P6PHCR_4:1;
		unsigned char P6PHCR_5:1;
		unsigned char P6PHCR_6:1;
		unsigned char P6PHCR_7:1;		
	};
} __P6PHCRbits_t;
extern volatile __P6PHCRbits_t __at(P6PHCR_ADDR) P6PHCRbits;

#define P6PHCR_0         P6PHCRbits.P6PHCR_0   	/* bit 0 */
#define P6PHCR_1         P6PHCRbits.P6PHCR_1    /* bit 1 */
#define P6PHCR_2         P6PHCRbits.P6PHCR_2    /* bit 2 */
#define P6PHCR_3         P6PHCRbits.P6PHCR_3    /* bit 3 */
#define P6PHCR_4         P6PHCRbits.P6PHCR_4   	/* bit 4 */
#define P6PHCR_5         P6PHCRbits.P6PHCR_5    /* bit 5 */
#define P6PHCR_6         P6PHCRbits.P6PHCR_6    /* bit 6 */
#define P6PHCR_7         P6PHCRbits.P6PHCR_7    /* bit 7 */

// ----- P7PHCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P7PHCR_0:1;
		unsigned char P7PHCR_1:1;
		unsigned char P7PHCR_2:1;
		unsigned char P7PHCR_3:1;	
		unsigned char P7PHCR_4:1;
		unsigned char P7PHCR_5:1;
		unsigned char P7PHCR_6:1;
		unsigned char P7PHCR_7:1;		
	};
} __P7PHCRbits_t;
extern volatile __P7PHCRbits_t __at(P7PHCR_ADDR) P7PHCRbits;

#define P7PHCR_0         P7PHCRbits.P7PHCR_0   	/* bit 0 */
#define P7PHCR_1         P7PHCRbits.P7PHCR_1    /* bit 1 */
#define P7PHCR_2         P7PHCRbits.P7PHCR_2    /* bit 2 */
#define P7PHCR_3         P7PHCRbits.P7PHCR_3    /* bit 3 */
#define P7PHCR_4         P7PHCRbits.P7PHCR_4   	/* bit 4 */
#define P7PHCR_5         P7PHCRbits.P7PHCR_5    /* bit 5 */
#define P7PHCR_6         P7PHCRbits.P7PHCR_6    /* bit 6 */
#define P7PHCR_7         P7PHCRbits.P7PHCR_7    /* bit 7 */

// ----- P5PDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5PDCR_0:1;
		unsigned char P5PDCR_1:1;
		unsigned char P5PDCR_2:1;
		unsigned char P5PDCR_3:1;	
		unsigned char P5PDCR_4:1;
		unsigned char P5PDCR_5:1;
		unsigned char P5PDCR_6:1;
		unsigned char P5PDCR_7:1;		
	};
} __P5PDCRbits_t;
extern volatile __P5PDCRbits_t __at(P5PDCR_ADDR) P5PDCRbits;

#define P5PDCR_0         P5PDCRbits.P5PDCR_0   	/* bit 0 */
#define P5PDCR_1         P5PDCRbits.P5PDCR_1    /* bit 1 */
#define P5PDCR_2         P5PDCRbits.P5PDCR_2    /* bit 2 */
#define P5PDCR_3         P5PDCRbits.P5PDCR_3    /* bit 3 */
#define P5PDCR_4         P5PDCRbits.P5PDCR_4   	/* bit 4 */
#define P5PDCR_5         P5PDCRbits.P5PDCR_5    /* bit 5 */
#define P5PDCR_6         P5PDCRbits.P5PDCR_6    /* bit 6 */
#define P5PDCR_7         P5PDCRbits.P5PDCR_7    /* bit 7 */

// ----- P6PDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6PDCR_0:1;
		unsigned char P6PDCR_1:1;
		unsigned char P6PDCR_2:1;
		unsigned char P6PDCR_3:1;	
		unsigned char P6PDCR_4:1;
		unsigned char P6PDCR_5:1;
		unsigned char P6PDCR_6:1;
		unsigned char P6PDCR_7:1;		
	};
} __P6PDCRbits_t;
extern volatile __P6PDCRbits_t __at(P6PDCR_ADDR) P6PDCRbits;

#define P6PDCR_0         P6PDCRbits.P6PDCR_0   	/* bit 0 */
#define P6PDCR_1         P6PDCRbits.P6PDCR_1    /* bit 1 */
#define P6PDCR_2         P6PDCRbits.P6PDCR_2    /* bit 2 */
#define P6PDCR_3         P6PDCRbits.P6PDCR_3    /* bit 3 */
#define P6PDCR_4         P6PDCRbits.P6PDCR_4   	/* bit 4 */
#define P6PDCR_5         P6PDCRbits.P6PDCR_5    /* bit 5 */
#define P6PDCR_6         P6PDCRbits.P6PDCR_6    /* bit 6 */
#define P6PDCR_7         P6PDCRbits.P6PDCR_7    /* bit 7 */

// ----- P7PDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P7PDCR_0:1;
		unsigned char P7PDCR_1:1;
		unsigned char P7PDCR_2:1;
		unsigned char P7PDCR_3:1;	
		unsigned char P7PDCR_4:1;
		unsigned char P7PDCR_5:1;
		unsigned char P7PDCR_6:1;
		unsigned char P7PDCR_7:1;		
	};
} __P7PDCRbits_t;
extern volatile __P7PDCRbits_t __at(P7PDCR_ADDR) P7PDCRbits;

#define P7PDCR_0         P7PDCRbits.P7PDCR_0   	/* bit 0 */
#define P7PDCR_1         P7PDCRbits.P7PDCR_1    /* bit 1 */
#define P7PDCR_2         P7PDCRbits.P7PDCR_2    /* bit 2 */
#define P7PDCR_3         P7PDCRbits.P7PDCR_3    /* bit 3 */
#define P7PDCR_4         P7PDCRbits.P7PDCR_4   	/* bit 4 */
#define P7PDCR_5         P7PDCRbits.P7PDCR_5    /* bit 5 */
#define P7PDCR_6         P7PDCRbits.P7PDCR_6    /* bit 6 */
#define P7PDCR_7         P7PDCRbits.P7PDCR_7    /* bit 7 */

// ----- P6ODCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6ODCR_0:1;
		unsigned char P6ODCR_1:1;
		unsigned char P6ODCR_2:1;
		unsigned char P6ODCR_3:1;	
		unsigned char P6ODCR_4:1;
		unsigned char P6ODCR_5:1;
		unsigned char P6ODCR_6:1;
		unsigned char P6ODCR_7:1;		
	};
} __P6ODCRbits_t;
extern volatile __P6ODCRbits_t __at(P6ODCR_ADDR) P6ODCRbits;

#define P6ODCR_0         P6ODCRbits.P6ODCR_0   	/* bit 0 */
#define P6ODCR_1         P6ODCRbits.P6ODCR_1    /* bit 1 */
#define P6ODCR_2         P6ODCRbits.P6ODCR_2    /* bit 2 */
#define P6ODCR_3         P6ODCRbits.P6ODCR_3    /* bit 3 */
#define P6ODCR_4         P6ODCRbits.P6ODCR_4   	/* bit 4 */
#define P6ODCR_5         P6ODCRbits.P6ODCR_5    /* bit 5 */
#define P6ODCR_6         P6ODCRbits.P6ODCR_6    /* bit 6 */
#define P6ODCR_7         P6ODCRbits.P6ODCR_7    /* bit 7 */

// ----- P5IWE Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5IWE_0:1;
		unsigned char P5IWE_1:1;
		unsigned char P5IWE_2:1;
		unsigned char P5IWE_3:1;	
		unsigned char P5IWE_4:1;
		unsigned char P5IWE_5:1;
		unsigned char P5IWE_6:1;
		unsigned char P5IWE_7:1;		
	};
} __P5IWEbits_t;
extern volatile __P5IWEbits_t __at(P5IWE_ADDR) P5IWEbits;

#define P5IWE_0         P5IWEbits.P5IWE_0   	/* bit 0 */
#define P5IWE_1         P5IWEbits.P5IWE_1       /* bit 1 */
#define P5IWE_2         P5IWEbits.P5IWE_2       /* bit 2 */
#define P5IWE_3         P5IWEbits.P5IWE_3       /* bit 3 */
#define P5IWE_4         P5IWEbits.P5IWE_4   	/* bit 4 */
#define P5IWE_5         P5IWEbits.P5IWE_5       /* bit 5 */
#define P5IWE_6         P5IWEbits.P5IWE_6       /* bit 6 */
#define P5IWE_7         P5IWEbits.P5IWE_7       /* bit 7 */

// ----- P6IWE Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6IWE_0:1;
		unsigned char P6IWE_1:1;
		unsigned char P6IWE_2:1;
		unsigned char P6IWE_3:1;	
		unsigned char P6IWE_4:1;
		unsigned char P6IWE_5:1;
		unsigned char P6IWE_6:1;
		unsigned char P6IWE_7:1;		
	};
} __P6IWEbits_t;
extern volatile __P6IWEbits_t __at(P6IWE_ADDR) P6IWEbits;

#define P6IWE_0         P6IWEbits.P6IWE_0   	/* bit 0 */
#define P6IWE_1         P6IWEbits.P6IWE_1       /* bit 1 */
#define P6IWE_2         P6IWEbits.P6IWE_2       /* bit 2 */
#define P6IWE_3         P6IWEbits.P6IWE_3       /* bit 3 */
#define P6IWE_4         P6IWEbits.P6IWE_4   	/* bit 4 */
#define P6IWE_5         P6IWEbits.P6IWE_5       /* bit 5 */
#define P6IWE_6         P6IWEbits.P6IWE_6       /* bit 6 */
#define P6IWE_7         P6IWEbits.P6IWE_7       /* bit 7 */

// ----- P7IWE Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P7IWE_0:1;
		unsigned char P7IWE_1:1;
		unsigned char P7IWE_2:1;
		unsigned char P7IWE_3:1;	
		unsigned char P7IWE_4:1;
		unsigned char P7IWE_5:1;
		unsigned char P7IWE_6:1;
		unsigned char P7IWE_7:1;		
	};
} __P7IWEbits_t;
extern volatile __P7IWEbits_t __at(P7IWE_ADDR) P7IWEbits;

#define P7IWE_0         P7IWEbits.P7IWE_0   	/* bit 0 */
#define P7IWE_1         P7IWEbits.P7IWE_1       /* bit 1 */
#define P7IWE_2         P7IWEbits.P7IWE_2       /* bit 2 */
#define P7IWE_3         P7IWEbits.P7IWE_3       /* bit 3 */
#define P7IWE_4         P7IWEbits.P7IWE_4   	/* bit 4 */
#define P7IWE_5         P7IWEbits.P7IWE_5       /* bit 5 */
#define P7IWE_6         P7IWEbits.P7IWE_6       /* bit 6 */
#define P7IWE_7         P7IWEbits.P7IWE_7       /* bit 7 */

// ----- P5HDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5HDCR_0:1;
		unsigned char P5HDCR_1:1;
		unsigned char P5HDCR_2:1;
		unsigned char P5HDCR_3:1;	
		unsigned char P5HDCR_4:1;
		unsigned char P5HDCR_5:1;
		unsigned char P5HDCR_6:1;
		unsigned char P5HDCR_7:1;		
	};
} __P5HDCRbits_t;
extern volatile __P5HDCRbits_t __at(P5HDCR_ADDR) P5HDCRbits;

#define P5HDCR_0         P5HDCRbits.P5HDCR_0   	/* bit 0 */
#define P5HDCR_1         P5HDCRbits.P5HDCR_1    /* bit 1 */
#define P5HDCR_2         P5HDCRbits.P5HDCR_2    /* bit 2 */
#define P5HDCR_3         P5HDCRbits.P5HDCR_3    /* bit 3 */
#define P5HDCR_4         P5HDCRbits.P5HDCR_4   	/* bit 4 */
#define P5HDCR_5         P5HDCRbits.P5HDCR_5    /* bit 5 */
#define P5HDCR_6         P5HDCRbits.P5HDCR_6    /* bit 6 */
#define P5HDCR_7         P5HDCRbits.P5HDCR_7    /* bit 7 */

// ----- P6HDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6HDCR_0:1;
		unsigned char P6HDCR_1:1;
		unsigned char P6HDCR_2:1;
		unsigned char P6HDCR_3:1;	
		unsigned char P6HDCR_4:1;
		unsigned char P6HDCR_5:1;
		unsigned char P6HDCR_6:1;
		unsigned char P6HDCR_7:1;		
	};
} __P6HDCRbits_t;
extern volatile __P6HDCRbits_t __at(P6HDCR_ADDR) P6HDCRbits;

#define P6HDCR_0         P6HDCRbits.P6HDCR_0   	/* bit 0 */
#define P6HDCR_1         P6HDCRbits.P6HDCR_1    /* bit 1 */
#define P6HDCR_2         P6HDCRbits.P6HDCR_2    /* bit 2 */
#define P6HDCR_3         P6HDCRbits.P6HDCR_3    /* bit 3 */
#define P6HDCR_4         P6HDCRbits.P6HDCR_4   	/* bit 4 */
#define P6HDCR_5         P6HDCRbits.P6HDCR_5    /* bit 5 */
#define P6HDCR_6         P6HDCRbits.P6HDCR_6    /* bit 6 */
#define P6HDCR_7         P6HDCRbits.P6HDCR_7    /* bit 7 */

// ----- P7HDCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P7HDCR_0:1;
		unsigned char P7HDCR_1:1;
		unsigned char P7HDCR_2:1;
		unsigned char P7HDCR_3:1;	
		unsigned char P7HDCR_4:1;
		unsigned char P7HDCR_5:1;
		unsigned char P7HDCR_6:1;
		unsigned char P7HDCR_7:1;		
	};
} __P7HDCRbits_t;
extern volatile __P7HDCRbits_t __at(P7HDCR_ADDR) P7HDCRbits;

#define P7HDCR_0         P7HDCRbits.P7HDCR_0   	/* bit 0 */
#define P7HDCR_1         P7HDCRbits.P7HDCR_1    /* bit 1 */
#define P7HDCR_2         P7HDCRbits.P7HDCR_2    /* bit 2 */
#define P7HDCR_3         P7HDCRbits.P7HDCR_3    /* bit 3 */
#define P7HDCR_4         P7HDCRbits.P7HDCR_4   	/* bit 4 */
#define P7HDCR_5         P7HDCRbits.P7HDCR_5    /* bit 5 */
#define P7HDCR_6         P7HDCRbits.P7HDCR_6    /* bit 6 */
#define P7HDCR_7         P7HDCRbits.P7HDCR_7    /* bit 7 */

// ----- P5HSCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5HSCR_0:1;
		unsigned char P5HSCR_1:1;
		unsigned char P5HSCR_2:1;
		unsigned char P5HSCR_3:1;	
		unsigned char P5HSCR_4:1;
		unsigned char P5HSCR_5:1;
		unsigned char P5HSCR_6:1;
		unsigned char P5HSCR_7:1;		
	};
} __P5HSCRbits_t;
extern volatile __P5HSCRbits_t __at(P5HSCR_ADDR) P5HSCRbits;

#define P5HSCR_0         P5HSCRbits.P5HSCR_0   	/* bit 0 */
#define P5HSCR_1         P5HSCRbits.P5HSCR_1    /* bit 1 */
#define P5HSCR_2         P5HSCRbits.P5HSCR_2    /* bit 2 */
#define P5HSCR_3         P5HSCRbits.P5HSCR_3    /* bit 3 */
#define P5HSCR_4         P5HSCRbits.P5HSCR_4   	/* bit 4 */
#define P5HSCR_5         P5HSCRbits.P5HSCR_5    /* bit 5 */
#define P5HSCR_6         P5HSCRbits.P5HSCR_6    /* bit 6 */
#define P5HSCR_7         P5HSCRbits.P5HSCR_7    /* bit 7 */

// ----- P6HSCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6HSCR_0:1;
		unsigned char P6HSCR_1:1;
		unsigned char P6HSCR_2:1;
		unsigned char P6HSCR_3:1;	
		unsigned char P6HSCR_4:1;
		unsigned char P6HSCR_5:1;
		unsigned char P6HSCR_6:1;
		unsigned char P6HSCR_7:1;		
	};
} __P6HSCRbits_t;
extern volatile __P6HSCRbits_t __at(P6HSCR_ADDR) P6HSCRbits;

#define P6HSCR_0         P6HSCRbits.P6HSCR_0   	/* bit 0 */
#define P6HSCR_1         P6HSCRbits.P6HSCR_1    /* bit 1 */
#define P6HSCR_2         P6HSCRbits.P6HSCR_2    /* bit 2 */
#define P6HSCR_3         P6HSCRbits.P6HSCR_3    /* bit 3 */
#define P6HSCR_4         P6HSCRbits.P6HSCR_4   	/* bit 4 */
#define P6HSCR_5         P6HSCRbits.P6HSCR_5    /* bit 5 */
#define P6HSCR_6         P6HSCRbits.P6HSCR_6    /* bit 6 */
#define P6HSCR_7         P6HSCRbits.P6HSCR_7    /* bit 7 */

// ----- P7HSCR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P7HSCR_0:1;
		unsigned char P7HSCR_1:1;
		unsigned char P7HSCR_2:1;
		unsigned char P7HSCR_3:1;	
		unsigned char P7HSCR_4:1;
		unsigned char P7HSCR_5:1;
		unsigned char P7HSCR_6:1;
		unsigned char P7HSCR_7:1;		
	};
} __P7HSCRbits_t;
extern volatile __P7HSCRbits_t __at(P7HSCR_ADDR) P7HSCRbits;

#define P7HSCR_0         P7HSCRbits.P7HSCR_0   	/* bit 0 */
#define P7HSCR_1         P7HSCRbits.P7HSCR_1    /* bit 1 */
#define P7HSCR_2         P7HSCRbits.P7HSCR_2    /* bit 2 */
#define P7HSCR_3         P7HSCRbits.P7HSCR_3    /* bit 3 */
#define P7HSCR_4         P7HSCRbits.P7HSCR_4   	/* bit 4 */
#define P7HSCR_5         P7HSCRbits.P7HSCR_5    /* bit 5 */
#define P7HSCR_6         P7HSCRbits.P7HSCR_6    /* bit 6 */
#define P7HSCR_7         P7HSCRbits.P7HSCR_7    /* bit 7 */

// ----- P5ADE Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P5ADE_0:1;
		unsigned char P5ADE_1:1;
		unsigned char P5ADE_2:1;
		unsigned char P5ADE_3:1;	
		unsigned char P5ADE_4:1;
		unsigned char P5ADE_5:1;
		unsigned char P5ADE_6:1;
		unsigned char P5ADE_7:1;		
	};
} __P5ADEbits_t;
extern volatile __P5ADEbits_t __at(P5ADE_ADDR) P5ADEbits;

#define P5ADE_0         P5ADEbits.P5ADE_0   	/* bit 0 */
#define P5ADE_1         P5ADEbits.P5ADE_1     	/* bit 1 */
#define P5ADE_2         P5ADEbits.P5ADE_2       /* bit 2 */
#define P5ADE_3         P5ADEbits.P5ADE_3       /* bit 3 */
#define P5ADE_4         P5ADEbits.P5ADE_4   	/* bit 4 */
#define P5ADE_5         P5ADEbits.P5ADE_5     	/* bit 5 */
#define P5ADE_6         P5ADEbits.P5ADE_6       /* bit 6 */
#define P5ADE_7         P5ADEbits.P5ADE_7       /* bit 7 */

// ----- P6ADE Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P6ADE_0:1;
		unsigned char P6ADE_1:1;
		unsigned char P6ADE_2:1;
		unsigned char P6ADE_3:1;	
		unsigned char P6ADE_4:1;
		unsigned char P6ADE_5:1;
		unsigned char P6ADE_6:1;
		unsigned char P6ADE_7:1;		
	};
} __P6ADEbits_t;
extern volatile __P6ADEbits_t __at(P6ADE_ADDR) P6ADEbits;

#define P6ADE_0         P6ADEbits.P6ADE_0   	/* bit 0 */
#define P6ADE_1         P6ADEbits.P6ADE_1     	/* bit 1 */
#define P6ADE_2         P6ADEbits.P6ADE_2       /* bit 2 */
#define P6ADE_3         P6ADEbits.P6ADE_3       /* bit 3 */
#define P6ADE_4         P6ADEbits.P6ADE_4   	/* bit 4 */
#define P6ADE_5         P6ADEbits.P6ADE_5     	/* bit 5 */
#define P6ADE_6         P6ADEbits.P6ADE_6       /* bit 6 */
#define P6ADE_7         P6ADEbits.P6ADE_7       /* bit 7 */

// ----- P7ADE Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char P7ADE_0:1;
		unsigned char P7ADE_1:1;
		unsigned char P7ADE_2:1;
		unsigned char P7ADE_3:1;	
		unsigned char P7ADE_4:1;
		unsigned char P7ADE_5:1;
		unsigned char P7ADE_6:1;
		unsigned char P7ADE_7:1;		
	};
} __P7ADEbits_t;
extern volatile __P7ADEbits_t __at(P7ADE_ADDR) P7ADEbits;

#define P7ADE_0         P7ADEbits.P7ADE_0   	/* bit 0 */
#define P7ADE_1         P7ADEbits.P7ADE_1     	/* bit 1 */
#define P7ADE_2         P7ADEbits.P7ADE_2       /* bit 2 */
#define P7ADE_3         P7ADEbits.P7ADE_3       /* bit 3 */
#define P7ADE_4         P7ADEbits.P7ADE_4   	/* bit 4 */
#define P7ADE_5         P7ADEbits.P7ADE_5     	/* bit 5 */
#define P7ADE_6         P7ADEbits.P7ADE_6       /* bit 6 */
#define P7ADE_7         P7ADEbits.P7ADE_7       /* bit 7 */

// ----- ADDATA Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ADDATA_0:1;
		unsigned char ADDATA_1:1;
		unsigned char ADDATA_2:1;
		unsigned char ADDATA_3:1;	
		unsigned char ADDATA_4:1;
		unsigned char ADDATA_5:1;
		unsigned char ADDATA_6:1;
		unsigned char ADDATA_7:1;		
	};
} __ADDATAbits_t;
extern volatile __ADDATAbits_t __at(ADDATA_ADDR) ADDATAbits;

#define ADDATA_0         ADDATAbits.ADDATA_0   	/* bit 0 */
#define ADDATA_1         ADDATAbits.ADDATA_1    /* bit 1 */
#define ADDATA_2         ADDATAbits.ADDATA_2    /* bit 2 */
#define ADDATA_3         ADDATAbits.ADDATA_3    /* bit 3 */
#define ADDATA_4         ADDATAbits.ADDATA_4   	/* bit 4 */
#define ADDATA_5         ADDATAbits.ADDATA_5    /* bit 5 */
#define ADDATA_6         ADDATAbits.ADDATA_6    /* bit 6 */
#define ADDATA_7         ADDATAbits.ADDATA_7    /* bit 7 */

// ----- ADDATA1H Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ADDATA1H_0:1;
		unsigned char ADDATA1H_1:1;
		unsigned char ADDATA1H_2:1;
		unsigned char ADDATA1H_3:1;	
		unsigned char ADDATA1H_4:1;
		unsigned char ADDATA1H_5:1;
		unsigned char ADDATA1H_6:1;
		unsigned char ADDATA1H_7:1;		
	};
} __ADDATA1Hbits_t;
extern volatile __ADDATA1Hbits_t __at(ADDATA1H_ADDR) ADDATA1Hbits;

#define ADDATA1H_0         ADDAA1Hbits.ADDATA1H_0   	/* bit 0 */
#define ADDATA1H_1         ADDATA1Hbits.ADDATA1H_1     	/* bit 1 */
#define ADDATA1H_2         ADDATA1Hbits.ADDATA1H_2      /* bit 2 */
#define ADDATA1H_3         ADDATA1Hbits.ADDATA1H_3      /* bit 3 */
#define ADDATA1H_4         ADDATA1Hbits.ADDATA1H_4   	/* bit 4 */
#define ADDATA1H_5         ADDATA1Hbits.ADDATA1H_5     	/* bit 5 */
#define ADDATA1H_6         ADDATA1Hbits.ADDATA1H_6      /* bit 6 */
#define ADDATA1H_7         ADDATA1Hbits.ADDATA1H_7      /* bit 7 */

// ----- ADDATA1L Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ADDATA1L_0:1;
		unsigned char ADDATA1L_1:1;
		unsigned char ADDATA1L_2:1;
		unsigned char ADDATA1L_3:1;	
		unsigned char ADDATA1L_4:1;
		unsigned char ADDATA1L_5:1;
		unsigned char ADDATA1L_6:1;
		unsigned char ADDATA1L_7:1;		
	};
} __ADDATA1Lbits_t;
extern volatile __ADDATA1Lbits_t __at(ADDATA1L_ADDR) ADDATA1Lbits;

#define ADDATA1L_0         ADDATA1Lbits.ADDATA1L_0   	/* bit 0 */
#define ADDATA1L_1         ADDATA1Lbits.ADDATA1L_1     	/* bit 1 */
#define ADDATA1L_2         ADDATA1Lbits.ADDATA1L_2      /* bit 2 */
#define ADDATA1L_3         ADDATA1Lbits.ADDATA1L_3      /* bit 3 */
#define ADDATA1L_4         ADDATA1Lbits.ADDATA1L_4   	/* bit 4 */
#define ADDATA1L_5         ADDATA1Lbits.ADDATA1L_5     	/* bit 5 */
#define ADDATA1L_6         ADDATA1Lbits.ADDATA1L_6      /* bit 6 */
#define ADDATA1L_7         ADDATA1Lbits.ADDATA1L_7      /* bit 7 */

// ----- ADIGS Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ADIGS_0:1;
		unsigned char ADIGS_1:1;
		unsigned char ADIGS_2:1;
		unsigned char ADIGS_3:1;	
		unsigned char ADIGS_4:1;
		unsigned char ADIGS_5:1;
		unsigned char ADIGS_6:1;
		unsigned char ADIGS_7:1;		
	};
} __ADIGSbits_t;
extern volatile __ADIGSbits_t __at(ADIGS_ADDR) ADIGSbits;

#define ADIGS_0         ADIGSbits.ADIGS_0   		/* bit 0 */
#define ADIGS_1         ADIGSbits.ADIGS_1     		/* bit 1 */
#define ADIGS_2         ADIGSbits.ADIGS_2          	/* bit 2 */
#define ADIGS_3         ADIGSbits.ADIGS_3          	/* bit 3 */
#define ADIGS_4         ADIGSbits.ADIGS_4   		/* bit 4 */
#define ADIGS_5         ADIGSbits.ADIGS_5     		/* bit 5 */
#define ADIGS_6         ADIGSbits.ADIGS_6          	/* bit 6 */
#define ADIGS_7         ADIGSbits.ADIGS_7          	/* bit 7 */

// ----- ADOC Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ADOC_0:1;
		unsigned char ADOC_1:1;
		unsigned char ADOC_2:1;
		unsigned char ADOC_3:1;	
		unsigned char ADOC_4:1;
		unsigned char ADOC_5:1;
		unsigned char ADOC_6:1;
		unsigned char ADOC_7:1;		
	};
} __ADOCbits_t;
extern volatile __ADOCbits_t __at(ADOC_ADDR) ADOCbits;

#define ADOC_0         	ADOCbits.ADOC_0   		/* bit 0 */
#define ADOC_1         	ADOCbits.ADOC_1     		/* bit 1 */
#define ADOC_2         	ADOCbits.ADOC_2          	/* bit 2 */
#define ADOC_3         	ADOCbits.ADOC_3          	/* bit 3 */
#define ADOC_4         	ADOCbits.ADOC_4   		/* bit 4 */
#define ADOC_5         	ADOCbits.ADOC_5     		/* bit 5 */
#define ADOC_6         	ADOCbits.ADOC_6          	/* bit 6 */
#define ADOC_7         	ADOCbits.ADOC_7          	/* bit 7 */

// ----- ADCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ADCON_0:1;
		unsigned char ADCON_1:1;
		unsigned char ADCON_2:1;
		unsigned char ADCON_3:1;	
		unsigned char ADCON_4:1;
		unsigned char ADCON_5:1;
		unsigned char ADCON_6:1;
		unsigned char ADCON_7:1;		
	};
} __ADCONbits_t;
extern volatile __ADCONbits_t __at(ADCON_ADDR) ADCONbits;

#define ADCON_0         ADCONbits.ADCON_0   		/* bit 0 */
#define ADCON_1         ADCONbits.ADCON_1     		/* bit 1 */
#define ADCON_2         ADCONbits.ADCON_2          	/* bit 2 */
#define ADCON_3         ADCONbits.ADCON_3          	/* bit 3 */
#define ADCON_4         ADCONbits.ADCON_4   		/* bit 4 */
#define ADCON_5         ADCONbits.ADCON_5     		/* bit 5 */
#define ADCON_6         ADCONbits.ADCON_6          	/* bit 6 */
#define ADCON_7         ADCONbits.ADCON_7          	/* bit 7 */

// ----- ADCMP Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ADCMP_0:1;
		unsigned char ADCMP_1:1;
		unsigned char ADCMP_2:1;
		unsigned char ADCMP_3:1;	
		unsigned char ADCMP_4:1;
		unsigned char ADCMP_5:1;
		unsigned char ADCMP_6:1;
		unsigned char ADCMP_7:1;		
	};
} __ADCMPbits_t;
extern volatile __ADCMPbits_t __at(ADCMP_ADDR) ADCMPbits;

#define ADCMP_0         ADCMPbits.ADCMP_0   		/* bit 0 */
#define ADCMP_1         ADCMPbits.ADCMP_1     		/* bit 1 */
#define ADCMP_2         ADCMPbits.ADCMP_2          	/* bit 2 */
#define ADCMP_3         ADCMPbits.ADCMP_3          	/* bit 3 */
#define ADCMP_4         ADCMPbits.ADCMP_4   		/* bit 4 */
#define ADCMP_5         ADCMPbits.ADCMP_5     		/* bit 5 */
#define ADCMP_6         ADCMPbits.ADCMP_6          	/* bit 6 */
#define ADCMP_7         ADCMPbits.ADCMP_7          	/* bit 7 */

// ----- LVDCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char LVDCON_0:1;
		unsigned char LVDCON_1:1;
		unsigned char LVDCON_2:1;
		unsigned char LVDCON_3:1;	
		unsigned char LVDCON_4:1;
		unsigned char LVDCON_5:1;
		unsigned char LVDCON_6:1;
		unsigned char LVDCON_7:1;		
	};
} __LVDCONbits_t;
extern volatile __LVDCONbits_t __at(LVDCON_ADDR) LVDCONbits;

#define LVDCON_0         LVDCONbits.LVDCON_0   		/* bit 0 */
#define LVDCON_1         LVDCONbits.LVDCON_1     	/* bit 1 */
#define LVDCON_2         LVDCONbits.LVDCON_2          	/* bit 2 */
#define LVDCON_3         LVDCONbits.LVDCON_3          	/* bit 3 */
#define LVDCON_4         LVDCONbits.LVDCON_4   		/* bit 4 */
#define LVDCON_5         LVDCONbits.LVDCON_5     	/* bit 5 */
#define LVDCON_6         LVDCONbits.LVDCON_6          	/* bit 6 */
#define LVDCON_7         LVDCONbits.LVDCON_7          	/* bit 7 */

// ----- WDTCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char WDTCON_0:1;
		unsigned char WDTCON_1:1;
		unsigned char WDTCON_2:1;
		unsigned char WDTCON_3:1;	
		unsigned char WDTCON_4:1;
		unsigned char WDTCON_5:1;
		unsigned char WDTCON_6:1;
		unsigned char WDTCON_7:1;		
	};
} __WDTCONbits_t;
extern volatile __WDTCONbits_t __at(WDTCON_ADDR) WDTCONbits;

#define WDTCON_0         WDTCONbits.WDTCON_0   		/* bit 0 */
#define WDTCON_1         WDTCONbits.WDTCON_1     	/* bit 1 */
#define WDTCON_2         WDTCONbits.WDTCON_2          	/* bit 2 */
#define WDTCON_3         WDTCONbits.WDTCON_3          	/* bit 3 */
#define WDTCON_4         WDTCONbits.WDTCON_4   		/* bit 4 */
#define WDTCON_5         WDTCONbits.WDTCON_5     	/* bit 5 */
#define WDTCON_6         WDTCONbits.WDTCON_6          	/* bit 6 */
#define WDTCON_7         WDTCONbits.WDTCON_7          	/* bit 7 */

// ----- PWM0CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM0CON_0:1;
		unsigned char PWM0CON_1:1;
		unsigned char PWM0CON_2:1;
		unsigned char PWM0CON_3:1;	
		unsigned char PWM0CON_4:1;
		unsigned char PWM0CON_5:1;
		unsigned char PWM0CON_6:1;
		unsigned char PWM0CON_7:1;		
	};
} __PWM0CONbits_t;
extern volatile __PWM0CONbits_t __at(PWM0CON_ADDR) PWM0CONbits;

#define PWM0CON_0         PWM0CONbits.PWM0CON_0   	/* bit 0 */
#define PWM0CON_1         PWM0CONbits.PWM0CON_1     	/* bit 1 */
#define PWM0CON_2         PWM0CONbits.PWM0CON_2         /* bit 2 */
#define PWM0CON_3         PWM0CONbits.PWM0CON_3         /* bit 3 */
#define PWM0CON_4         PWM0CONbits.PWM0CON_4   	/* bit 4 */
#define PWM0CON_5         PWM0CONbits.PWM0CON_5     	/* bit 5 */
#define PWM0CON_6         PWM0CONbits.PWM0CON_6         /* bit 6 */
#define PWM0CON_7         PWM0CONbits.PWM0CON_7         /* bit 7 */

// ----- PWM0RD Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM0RD_0:1;
		unsigned char PWM0RD_1:1;
		unsigned char PWM0RD_2:1;
		unsigned char PWM0RD_3:1;	
		unsigned char PWM0RD_4:1;
		unsigned char PWM0RD_5:1;
		unsigned char PWM0RD_6:1;
		unsigned char PWM0RD_7:1;		
	};
} __PWM0RDbits_t;
extern volatile __PWM0RDbits_t __at(PWM0RD_ADDR) PWM0RDbits;

#define PWM0RD_0         PWM0RDbits.PWM0RD_0   		/* bit 0 */
#define PWM0RD_1         PWM0RDbits.PWM0RD_1     	/* bit 1 */
#define PWM0RD_2         PWM0RDbits.PWM0RD_2          	/* bit 2 */
#define PWM0RD_3         PWM0RDbits.PWM0RD_3          	/* bit 3 */
#define PWM0RD_4         PWM0RDbits.PWM0RD_4   		/* bit 4 */
#define PWM0RD_5         PWM0RDbits.PWM0RD_5     	/* bit 5 */
#define PWM0RD_6         PWM0RDbits.PWM0RD_6          	/* bit 6 */
#define PWM0RD_7         PWM0RDbits.PWM0RD_7          	/* bit 7 */

// ----- PWM0DT Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM0DT_0:1;
		unsigned char PWM0DT_1:1;
		unsigned char PWM0DT_2:1;
		unsigned char PWM0DT_3:1;	
		unsigned char PWM0DT_4:1;
		unsigned char PWM0DT_5:1;
		unsigned char PWM0DT_6:1;
		unsigned char PWM0DT_7:1;		
	};
} __PWM0DTbits_t;
extern volatile __PWM0DTbits_t __at(PWM0DT_ADDR) PWM0DTbits;

#define PWM0DT_0         PWM0DTbits.PWM0DT_0   		/* bit 0 */
#define PWM0DT_1         PWM0DTbits.PWM0DT_1     	/* bit 1 */
#define PWM0DT_2         PWM0DTbits.PWM0DT_2          	/* bit 2 */
#define PWM0DT_3         PWM0DTbits.PWM0DT_3          	/* bit 3 */
#define PWM0DT_4         PWM0DTbits.PWM0DT_4   		/* bit 4 */
#define PWM0DT_5         PWM0DTbits.PWM0DT_5     	/* bit 5 */
#define PWM0DT_6         PWM0DTbits.PWM0DT_6          	/* bit 6 */
#define PWM0DT_7         PWM0DTbits.PWM0DT_7          	/* bit 7 */

// ----- TMR0 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TMR0_0:1;
		unsigned char TMR0_1:1;
		unsigned char TMR0_2:1;
		unsigned char TMR0_3:1;	
		unsigned char TMR0_4:1;
		unsigned char TMR0_5:1;
		unsigned char TMR0_6:1;
		unsigned char TMR0_7:1;		
	};
} __TMR0bits_t;
extern volatile __TMR0bits_t __at(TMR0_ADDR) TMR0bits;

#define TMR0_0         	TMR0bits.TMR0_0   		/* bit 0 */
#define TMR0_1         	TMR0bits.TMR0_1     		/* bit 1 */
#define TMR0_2         	TMR0bits.TMR0_2          	/* bit 2 */
#define TMR0_3         	TMR0bits.TMR0_3          	/* bit 3 */
#define TMR0_4         	TMR0bits.TMR0_4   		/* bit 4 */
#define TMR0_5         	TMR0bits.TMR0_5     		/* bit 5 */
#define TMR0_6         	TMR0bits.TMR0_6          	/* bit 6 */
#define TMR0_7         	TMR0bits.TMR0_7          	/* bit 7 */

// ----- PWM1CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM1CON_0:1;
		unsigned char PWM1CON_1:1;
		unsigned char PWM1CON_2:1;
		unsigned char PWM1CON_3:1;	
		unsigned char PWM1CON_4:1;
		unsigned char PWM1CON_5:1;
		unsigned char PWM1CON_6:1;
		unsigned char PWM1CON_7:1;		
	};
} __PWM1CONbits_t;
extern volatile __PWM1CONbits_t __at(PWM1CON_ADDR) PWM1CONbits;

#define PWM1CON_0         PWM1CONbits.PWM1CON_0   	/* bit 0 */
#define PWM1CON_1         PWM1CONbits.PWM1CON_1     	/* bit 1 */
#define PWM1CON_2         PWM1CONbits.PWM1CON_2         /* bit 2 */
#define PWM1CON_3         PWM1CONbits.PWM1CON_3         /* bit 3 */
#define PWM1CON_4         PWM1CONbits.PWM1CON_4   	/* bit 4 */
#define PWM1CON_5         PWM1CONbits.PWM1CON_5     	/* bit 5 */
#define PWM1CON_6         PWM1CONbits.PWM1CON_6         /* bit 6 */
#define PWM1CON_7         PWM1CONbits.PWM1CON_7         /* bit 7 */

// ----- PWM1RD Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM1RD_0:1;
		unsigned char PWM1RD_1:1;
		unsigned char PWM1RD_2:1;
		unsigned char PWM1RD_3:1;	
		unsigned char PWM1RD_4:1;
		unsigned char PWM1RD_5:1;
		unsigned char PWM1RD_6:1;
		unsigned char PWM1RD_7:1;		
	};
} __PWM1RDbits_t;
extern volatile __PWM1RDbits_t __at(PWM1RD_ADDR) PWM1RDbits;

#define PWM1RD_0         PWM1RDbits.PWM1RD_0   		/* bit 0 */
#define PWM1RD_1         PWM1RDbits.PWM1RD_1     	/* bit 1 */
#define PWM1RD_2         PWM1RDbits.PWM1RD_2          	/* bit 2 */
#define PWM1RD_3         PWM1RDbits.PWM1RD_3          	/* bit 3 */
#define PWM1RD_4         PWM1RDbits.PWM1RD_4   		/* bit 4 */
#define PWM1RD_5         PWM1RDbits.PWM1RD_5     	/* bit 5 */
#define PWM1RD_6         PWM1RDbits.PWM1RD_6          	/* bit 6 */
#define PWM1RD_7         PWM1RDbits.PWM1RD_7          	/* bit 7 */

// ----- PWM1DT Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM1DT_0:1;
		unsigned char PWM1DT_1:1;
		unsigned char PWM1DT_2:1;
		unsigned char PWM1DT_3:1;	
		unsigned char PWM1DT_4:1;
		unsigned char PWM1DT_5:1;
		unsigned char PWM1DT_6:1;
		unsigned char PWM1DT_7:1;		
	};
} __PWM1DTbits_t;
extern volatile __PWM1DTbits_t __at(PWM1DT_ADDR) PWM1DTbits;

#define PWM1DT_0         PWM1DTbits.PWM1DT_0   		/* bit 0 */
#define PWM1DT_1         PWM1DTbits.PWM1DT_1     	/* bit 1 */
#define PWM1DT_2         PWM1DTbits.PWM1DT_2          	/* bit 2 */
#define PWM1DT_3         PWM1DTbits.PWM1DT_3          	/* bit 3 */
#define PWM1DT_4         PWM1DTbits.PWM1DT_4   		/* bit 4 */
#define PWM1DT_5         PWM1DTbits.PWM1DT_5     	/* bit 5 */
#define PWM1DT_6         PWM1DTbits.PWM1DT_6          	/* bit 6 */
#define PWM1DT_7         PWM1DTbits.PWM1DT_7          	/* bit 7 */

// ----- TMR1 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TMR1_0:1;
		unsigned char TMR1_1:1;
		unsigned char TMR1_2:1;
		unsigned char TMR1_3:1;	
		unsigned char TMR1_4:1;
		unsigned char TMR1_5:1;
		unsigned char TMR1_6:1;
		unsigned char TMR1_7:1;		
	};
} __TMR1bits_t;
extern volatile __TMR1bits_t __at(TMR1_ADDR) TMR1bits;

#define TMR1_0         	 TMR1bits.TMR1_0   		/* bit 0 */
#define TMR1_1         	 TMR1bits.TMR1_1     		/* bit 1 */
#define TMR1_2         	 TMR1bits.TMR1_2          	/* bit 2 */
#define TMR1_3         	 TMR1bits.TMR1_3          	/* bit 3 */
#define TMR1_4         	 TMR1bits.TMR1_4   		/* bit 4 */
#define TMR1_5         	 TMR1bits.TMR1_5     		/* bit 5 */
#define TMR1_6         	 TMR1bits.TMR1_6          	/* bit 6 */
#define TMR1_7         	 TMR1bits.TMR1_7          	/* bit 7 */

// ----- PWM2CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM2CON_0:1;
		unsigned char PWM2CON_1:1;
		unsigned char PWM2CON_2:1;
		unsigned char PWM2CON_3:1;	
		unsigned char PWM2CON_4:1;
		unsigned char PWM2CON_5:1;
		unsigned char PWM2CON_6:1;
		unsigned char PWM2CON_7:1;		
	};
} __PWM2CONbits_t;
extern volatile __PWM2CONbits_t __at(PWM2CON_ADDR) PWM2CONbits;

#define PWM2CON_0        PWM2CONbits.PWM2CON_0   	/* bit 0 */
#define PWM2CON_1        PWM2CONbits.PWM2CON_1     	/* bit 1 */
#define PWM2CON_2        PWM2CONbits.PWM2CON_2          /* bit 2 */
#define PWM2CON_3        PWM2CONbits.PWM2CON_3          /* bit 3 */
#define PWM2CON_4        PWM2CONbits.PWM2CON_4   	/* bit 4 */
#define PWM2CON_5        PWM2CONbits.PWM2CON_5     	/* bit 5 */
#define PWM2CON_6        PWM2CONbits.PWM2CON_6          /* bit 6 */
#define PWM2CON_7        PWM2CONbits.PWM2CON_7          /* bit 7 */

// ----- PWM2RD Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM2RD_0:1;
		unsigned char PWM2RD_1:1;
		unsigned char PWM2RD_2:1;
		unsigned char PWM2RD_3:1;	
		unsigned char PWM2RD_4:1;
		unsigned char PWM2RD_5:1;
		unsigned char PWM2RD_6:1;
		unsigned char PWM2RD_7:1;		
	};
} __PWM2RDbits_t;
extern volatile __PWM2RDbits_t __at(PWM2RD_ADDR) PWM2RDbits;

#define PWM2RD_0         PWM2RDbits.PWM2RD_0   		/* bit 0 */
#define PWM2RD_1         PWM2RDbits.PWM2RD_1     	/* bit 1 */
#define PWM2RD_2         PWM2RDbits.PWM2RD_2          	/* bit 2 */
#define PWM2RD_3         PWM2RDbits.PWM2RD_3          	/* bit 3 */
#define PWM2RD_4         PWM2RDbits.PWM2RD_4   		/* bit 4 */
#define PWM2RD_5         PWM2RDbits.PWM2RD_5     	/* bit 5 */
#define PWM2RD_6         PWM2RDbits.PWM2RD_6          	/* bit 6 */
#define PWM2RD_7         PWM2RDbits.PWM2RD_7          	/* bit 7 */

// ----- PWM2DT Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM2DT_0:1;
		unsigned char PWM2DT_1:1;
		unsigned char PWM2DT_2:1;
		unsigned char PWM2DT_3:1;	
		unsigned char PWM2DT_4:1;
		unsigned char PWM2DT_5:1;
		unsigned char PWM2DT_6:1;
		unsigned char PWM2DT_7:1;		
	};
} __PWM2DTbits_t;
extern volatile __PWM2DTbits_t __at(PWM2DT_ADDR) PWM2DTbits;

#define PWM2DT_0         PWM2DTbits.PWM2DT_0   		/* bit 0 */
#define PWM2DT_1         PWM2DTbits.PWM2DT_1     	/* bit 1 */
#define PWM2DT_2         PWM2DTbits.PWM2DT_2          	/* bit 2 */
#define PWM2DT_3         PWM2DTbits.PWM2DT_3          	/* bit 3 */
#define PWM2DT_4         PWM2DTbits.PWM2DT_4   		/* bit 4 */
#define PWM2DT_5         PWM2DTbits.PWM2DT_5     	/* bit 5 */
#define PWM2DT_6         PWM2DTbits.PWM2DT_6          	/* bit 6 */
#define PWM2DT_7         PWM2DTbits.PWM2DT_7          	/* bit 7 */

// ----- TMR2 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TMR2_0:1;
		unsigned char TMR2_1:1;
		unsigned char TMR2_2:1;
		unsigned char TMR2_3:1;	
		unsigned char TMR2_4:1;
		unsigned char TMR2_5:1;
		unsigned char TMR2_6:1;
		unsigned char TMR2_7:1;		
	};
} __TMR2bits_t;
extern volatile __TMR2bits_t __at(TMR2_ADDR) TMR2bits;

#define TMR2_0         	TMR2bits.TMR2_0   		/* bit 0 */
#define TMR2_1         	TMR2bits.TMR2_1     		/* bit 1 */
#define TMR2_2         	TMR2bits.TMR2_2          	/* bit 2 */
#define TMR2_3         	TMR2bits.TMR2_3          	/* bit 3 */
#define TMR2_4         	TMR2bits.TMR2_4   		/* bit 4 */
#define TMR2_5         	TMR2bits.TMR2_5     		/* bit 5 */
#define TMR2_6         	TMR2bits.TMR2_6          	/* bit 6 */
#define TMR2_7         	TMR2bits.TMR2_7          	/* bit 7 */

// ----- PWM3CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM3CON_0:1;
		unsigned char PWM3CON_1:1;
		unsigned char PWM3CON_2:1;
		unsigned char PWM3CON_3:1;	
		unsigned char PWM3CON_4:1;
		unsigned char PWM3CON_5:1;
		unsigned char PWM3CON_6:1;
		unsigned char PWM3CON_7:1;		
	};
} __PWM3CONbits_t;
extern volatile __PWM3CONbits_t __at(PWM3CON_ADDR) PWM3CONbits;

#define PWM3CON_0         PWM3CONbits.PWM3CON_0   	/* bit 0 */
#define PWM3CON_1         PWM3CONbits.PWM3CON_1     	/* bit 1 */
#define PWM3CON_2         PWM3CONbits.PWM3CON_2         /* bit 2 */
#define PWM3CON_3         PWM3CONbits.PWM3CON_3         /* bit 3 */
#define PWM3CON_4         PWM3CONbits.PWM3CON_4   	/* bit 4 */
#define PWM3CON_5         PWM3CONbits.PWM3CON_5     	/* bit 5 */
#define PWM3CON_6         PWM3CONbits.PWM3CON_6         /* bit 6 */
#define PWM3CON_7         PWM3CONbits.PWM3CON_7         /* bit 7 */

// ----- PWM3RD Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM3RD_0:1;
		unsigned char PWM3RD_1:1;
		unsigned char PWM3RD_2:1;
		unsigned char PWM3RD_3:1;	
		unsigned char PWM3RD_4:1;
		unsigned char PWM3RD_5:1;
		unsigned char PWM3RD_6:1;
		unsigned char PWM3RD_7:1;		
	};
} __PWM3RDbits_t;
extern volatile __PWM3RDbits_t __at(PWM3RD_ADDR) PWM3RDbits;

#define PWM3RD_0         PWM3RDbits.PWM3RD_0   		/* bit 0 */
#define PWM3RD_1         PWM3RDbits.PWM3RD_1     	/* bit 1 */
#define PWM3RD_2         PWM3RDbits.PWM3RD_2          	/* bit 2 */
#define PWM3RD_3         PWM3RDbits.PWM3RD_3          	/* bit 3 */
#define PWM3RD_4         PWM3RDbits.PWM3RD_4   		/* bit 4 */
#define PWM3RD_5         PWM3RDbits.PWM3RD_5     	/* bit 5 */
#define PWM3RD_6         PWM3RDbits.PWM3RD_6          	/* bit 6 */
#define PWM3RD_7         PWM3RDbits.PWM3RD_7          	/* bit 7 */

// ----- PWM3DT Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWM3DT_0:1;
		unsigned char PWM3DT_1:1;
		unsigned char PWM3DT_2:1;
		unsigned char PWM3DT_3:1;	
		unsigned char PWM3DT_4:1;
		unsigned char PWM3DT_5:1;
		unsigned char PWM3DT_6:1;
		unsigned char PWM3DT_7:1;		
	};
} __PWM3DTbits_t;
extern volatile __PWM3DTbits_t __at(PWM3DT_ADDR) PWM3DTbits;

#define PWM3DT_0         PWM3DTbits.PWM3DT_0   		/* bit 0 */
#define PWM3DT_1         PWM3DTbits.PWM3DT_1     	/* bit 1 */
#define PWM3DT_2         PWM3DTbits.PWM3DT_2          	/* bit 2 */
#define PWM3DT_3         PWM3DTbits.PWM3DT_3          	/* bit 3 */
#define PWM3DT_4         PWM3DTbits.PWM3DT_4   		/* bit 4 */
#define PWM3DT_5         PWM3DTbits.PWM3DT_5     	/* bit 5 */
#define PWM3DT_6         PWM3DTbits.PWM3DT_6          	/* bit 6 */
#define PWM3DT_7         PWM3DTbits.PWM3DT_7          	/* bit 7 */

// ----- TMR3 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TMR3_0:1;
		unsigned char TMR3_1:1;
		unsigned char TMR3_2:1;
		unsigned char TMR3_3:1;	
		unsigned char TMR3_4:1;
		unsigned char TMR3_5:1;
		unsigned char TMR3_6:1;
		unsigned char TMR3_7:1;		
	};
} __TMR3bits_t;
extern volatile __TMR3bits_t __at(TMR3_ADDR) TMR3bits;

#define TMR3_0         	TMR3bits.TMR3_0   		/* bit 0 */
#define TMR3_1         	TMR3bits.TMR3_1     		/* bit 1 */
#define TMR3_2         	TMR3bits.TMR3_2          	/* bit 2 */
#define TMR3_3         	TMR3bits.TMR3_3          	/* bit 3 */
#define TMR3_4         	TMR3bits.TMR3_4   		/* bit 4 */
#define TMR3_5         	TMR3bits.TMR3_5     		/* bit 5 */
#define TMR3_6         	TMR3bits.TMR3_6          	/* bit 6 */
#define TMR3_7         	TMR3bits.TMR3_7          	/* bit 7 */

// ----- PWMCS Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWMCS_0:1;
		unsigned char PWMCS_1:1;
		unsigned char PWMCS_2:1;
		unsigned char PWMCS_3:1;	
		unsigned char PWMCS_4:1;
		unsigned char PWMCS_5:1;
		unsigned char PWMCS_6:1;
		unsigned char PWMCS_7:1;		
	};
} __PWMCSbits_t;
extern volatile __PWMCSbits_t __at(PWMCS_ADDR) PWMCSbits;

#define PWMCS_0         PWMCSbits.PWMCS_0   		/* bit 0 */
#define PWMCS_1         PWMCSbits.PWMCS_1     		/* bit 1 */
#define PWMCS_2         PWMCSbits.PWMCS_2          	/* bit 2 */
#define PWMCS_3        	PWMCSbits.PWMCS_3          	/* bit 3 */
#define PWMCS_4         PWMCSbits.PWMCS_4   		/* bit 4 */
#define PWMCS_5         PWMCSbits.PWMCS_5     		/* bit 5 */
#define PWMCS_6         PWMCSbits.PWMCS_6          	/* bit 6 */
#define PWMCS_7         PWMCSbits.PWMCS_7          	/* bit 7 */

// ----- PWMDEADT Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWMDEADT_0:1;
		unsigned char PWMDEADT_1:1;
		unsigned char PWMDEADT_2:1;
		unsigned char PWMDEADT_3:1;	
		unsigned char PWMDEADT_4:1;
		unsigned char PWMDEADT_5:1;
		unsigned char PWMDEADT_6:1;
		unsigned char PWMDEADT_7:1;		
	};
} __PWMDEADTbits_t;
extern volatile __PWMDEADTbits_t __at(PWMDEADT_ADDR) PWMDEADTbits;

#define PWMDEADT_0      PWMDEADTbits.PWMDEADT_0   	/* bit 0 */
#define PWMDEADT_1      PWMDEADTbits.PWMDEADT_1     	/* bit 1 */
#define PWMDEADT_2      PWMDEADTbits.PWMDEADT_2         /* bit 2 */
#define PWMDEADT_3      PWMDEADTbits.PWMDEADT_3         /* bit 3 */
#define PWMDEADT_4      PWMDEADTbits.PWMDEADT_4   	/* bit 4 */
#define PWMDEADT_5      PWMDEADTbits.PWMDEADT_5     	/* bit 5 */
#define PWMDEADT_6      PWMDEADTbits.PWMDEADT_6         /* bit 6 */
#define PWMDEADT_7      PWMDEADTbits.PWMDEADT_7         /* bit 7 */

// ----- PWMIS1 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWMIS1_0:1;
		unsigned char PWMIS1_1:1;
		unsigned char PWMIS1_2:1;
		unsigned char PWMIS1_3:1;	
		unsigned char PWMIS1_4:1;
		unsigned char PWMIS1_5:1;
		unsigned char PWMIS1_6:1;
		unsigned char PWMIS1_7:1;		
	};
} __PWMIS1bits_t;
extern volatile __PWMIS1bits_t __at(PWMIS1_ADDR) PWMIS1bits;

#define PWMIS1_0         PWMIS1bits.PWMIS1_0   		/* bit 0 */
#define PWMIS1_1         PWMIS1bits.PWMIS1_1     	/* bit 1 */
#define PWMIS1_2         PWMIS1bits.PWMIS1_2          	/* bit 2 */
#define PWMIS1_3         PWMIS1bits.PWMIS1_3          	/* bit 3 */
#define PWMIS1_4         PWMIS1bits.PWMIS1_4   		/* bit 4 */
#define PWMIS1_5         PWMIS1bits.PWMIS1_5     	/* bit 5 */
#define PWMIS1_6         PWMIS1bits.PWMIS1_6          	/* bit 6 */
#define PWMIS1_7         PWMIS1bits.PWMIS1_7          	/* bit 7 */

// ----- PWMIS2 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char PWMIS2_0:1;
		unsigned char PWMIS2_1:1;
		unsigned char PWMIS2_2:1;
		unsigned char PWMIS2_3:1;	
		unsigned char PWMIS2_4:1;
		unsigned char PWMIS2_5:1;
		unsigned char PWMIS2_6:1;
		unsigned char PWMIS2_7:1;		
	};
} __PWMIS2bits_t;
extern volatile __PWMIS2bits_t __at(PWMIS2_ADDR) PWMIS2bits;

#define PWMIS2_0         PWMIS2bits.PWMIS2_0   		/* bit 0 */
#define PWMIS2_1         PWMIS2bits.PWMIS2_1     	/* bit 1 */
#define PWMIS2_2         PWMIS2bits.PWMIS2_2          	/* bit 2 */
#define PWMIS2_3         PWMIS2bits.PWMIS2_3          	/* bit 3 */
#define PWMIS2_4         PWMIS2bits.PWMIS2_4   		/* bit 4 */
#define PWMIS2_5         PWMIS2bits.PWMIS2_5     	/* bit 5 */
#define PWMIS2_6         PWMIS2bits.PWMIS2_6          	/* bit 6 */
#define PWMIS2_7         PWMIS2bits.PWMIS2_7          	/* bit 7 */

// ----- TC1CON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TC1CON_0:1;
		unsigned char TC1CON_1:1;
		unsigned char TC1CON_2:1;
		unsigned char TC1CON_3:1;	
		unsigned char TC1CON_4:1;
		unsigned char TC1CON_5:1;
		unsigned char TC1CON_6:1;
		unsigned char TC1CON_7:1;		
	};
} __TC1CONbits_t;
extern volatile __TC1CONbits_t __at(TC1CON_ADDR) TC1CONbits;

#define TC1CON_0         TC1CONbits.TC1CON_0   		/* bit 0 */
#define TC1CON_1         TC1CONbits.TC1CON_1     	/* bit 1 */
#define TC1CON_2         TC1CONbits.TC1CON_2          	/* bit 2 */
#define TC1CON_3         TC1CONbits.TC1CON_3          	/* bit 3 */
#define TC1CON_4         TC1CONbits.TC1CON_4   		/* bit 4 */
#define TC1CON_5         TC1CONbits.TC1CON_5     	/* bit 5 */
#define TC1CON_6         TC1CONbits.TC1CON_6          	/* bit 6 */
#define TC1CON_7         TC1CONbits.TC1CON_7          	/* bit 7 */

// ----- TC1H Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TC1H_0:1;
		unsigned char TC1H_1:1;
		unsigned char TC1H_2:1;
		unsigned char TC1H_3:1;	
		unsigned char TC1H_4:1;
		unsigned char TC1H_5:1;
		unsigned char TC1H_6:1;
		unsigned char TC1H_7:1;		
	};
} __TC1Hbits_t;
extern volatile __TC1Hbits_t __at(TC1H_ADDR) TC1Hbits;

#define TC1H_0         	TC1Hbits.TC1H_0   		/* bit 0 */
#define TC1H_1         	TC1Hbits.TC1H_1     		/* bit 1 */
#define TC1H_2         	TC1Hbits.TC1H_2          	/* bit 2 */
#define TC1H_3         	TC1Hbits.TC1H_3          	/* bit 3 */
#define TC1H_4         	TC1Hbits.TC1H_4   		/* bit 4 */
#define TC1H_5         	TC1Hbits.TC1H_5     		/* bit 5 */
#define TC1H_6         	TC1Hbits.TC1H_6          	/* bit 6 */
#define TC1H_7         	TC1Hbits.TC1H_7          	/* bit 7 */

// ----- TC1L Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char TC1L_0:1;
		unsigned char TC1L_1:1;
		unsigned char TC1L_2:1;
		unsigned char TC1L_3:1;	
		unsigned char TC1L_4:1;
		unsigned char TC1L_5:1;
		unsigned char TC1L_6:1;
		unsigned char TC1L_7:1;		
	};
} __TC1Lbits_t;
extern volatile __TC1Lbits_t __at(TC1L_ADDR) TC1Lbits;

#define TC1L_0         	TC1Lbits.TC1L_0   		/* bit 0 */
#define TC1L_1         	TC1Lbits.TC1L_1     		/* bit 1 */
#define TC1L_2         	TC1Lbits.TC1L_2          	/* bit 2 */
#define TC1L_3         	TC1Lbits.TC1L_3          	/* bit 3 */
#define TC1L_4         	TC1Lbits.TC1L_4   		/* bit 4 */
#define TC1L_5         	TC1Lbits.TC1L_5     		/* bit 5 */
#define TC1L_6         	TC1Lbits.TC1L_6          	/* bit 6 */
#define TC1L_7         	TC1Lbits.TC1L_7          	/* bit 7 */

// ----- EINTR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char EINTR_0:1;
		unsigned char EINTR_1:1;
		unsigned char EINTR_2:1;
		unsigned char EINTR_3:1;	
		unsigned char EINTR_4:1;
		unsigned char EINTR_5:1;
		unsigned char EINTR_6:1;
		unsigned char EINTR_7:1;		
	};
} __EINTRbits_t;
extern volatile __EINTRbits_t __at(EINTR_ADDR) EINTRbits;

#define EINTR_0         EINTRbits.EINTR_0   		/* bit 0 */
#define EINTR_1         EINTRbits.EINTR_1     		/* bit 1 */
#define EINTR_2         EINTRbits.EINTR_2          	/* bit 2 */
#define EINTR_3         EINTRbits.EINTR_3          	/* bit 3 */
#define EINTR_4         EINTRbits.EINTR_4   		/* bit 4 */
#define EINTR_5         EINTRbits.EINTR_5     		/* bit 5 */
#define EINTR_6         EINTRbits.EINTR_6          	/* bit 6 */
#define EINTR_7         EINTRbits.EINTR_7          	/* bit 7 */

// ----- IMR1 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char IMR1_0:1;
		unsigned char IMR1_1:1;
		unsigned char IMR1_2:1;
		unsigned char IMR1_3:1;	
		unsigned char IMR1_4:1;
		unsigned char IMR1_5:1;
		unsigned char IMR1_6:1;
		unsigned char IMR1_7:1;		
	};
} __IMR1bits_t;
extern volatile __IMR1bits_t __at(IMR1_ADDR) IMR1bits;

#define IMR1_0         	IMR1bits.IMR1_0   		/* bit 0 */
#define IMR1_1         	IMR1bits.IMR1_1     		/* bit 1 */
#define IMR1_2         	IMR1bits.IMR1_2          	/* bit 2 */
#define IMR1_3         	IMR1bits.IMR1_3          	/* bit 3 */
#define IMR1_4         	IMR1bits.IMR1_4   		/* bit 4 */
#define IMR1_5         	IMR1bits.IMR1_5     		/* bit 5 */
#define IMR1_6         	IMR1bits.IMR1_6          	/* bit 6 */
#define IMR1_7         	IMR1bits.IMR1_7          	/* bit 7 */

// ----- IMR2 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char IMR2_0:1;
		unsigned char IMR2_1:1;
		unsigned char IMR2_2:1;
		unsigned char IMR2_3:1;	
		unsigned char IMR2_4:1;
		unsigned char IMR2_5:1;
		unsigned char IMR2_6:1;
		unsigned char IMR2_7:1;		
	};
} __IMR2bits_t;
extern volatile __IMR2bits_t __at(IMR2_ADDR) IMR2bits;

#define IMR2_0         	IMR2bits.IMR2_0   		/* bit 0 */
#define IMR2_1         	IMR2bits.IMR2_1     		/* bit 1 */
#define IMR2_2         	IMR2bits.IMR2_2          	/* bit 2 */
#define IMR2_3         	IMR2bits.IMR2_3          	/* bit 3 */
#define IMR2_4         	IMR2bits.IMR2_4   		/* bit 4 */
#define IMR2_5         	IMR2bits.IMR2_5     		/* bit 5 */
#define IMR2_6         	IMR2bits.IMR2_6          	/* bit 6 */
#define IMR2_7         	IMR2bits.IMR2_7          	/* bit 7 */

// ----- ISR1 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ISR1_0:1;
		unsigned char ISR1_1:1;
		unsigned char ISR1_2:1;
		unsigned char ISR1_3:1;	
		unsigned char ISR1_4:1;
		unsigned char ISR1_5:1;
		unsigned char ISR1_6:1;
		unsigned char ISR1_7:1;		
	};
} __ISR1bits_t;
extern volatile __ISR1bits_t __at(ISR1_ADDR) ISR1bits;

#define ISR1_0         	ISR1bits.ISR1_0   		/* bit 0 */
#define ISR1_1         	ISR1bits.ISR1_1     		/* bit 1 */
#define ISR1_2         	ISR1bits.ISR1_2          	/* bit 2 */
#define ISR1_3         	ISR1bits.ISR1_3          	/* bit 3 */
#define ISR1_4         	ISR1bits.ISR1_4   		/* bit 4 */
#define ISR1_5         	ISR1bits.ISR1_5     		/* bit 5 */
#define ISR1_6         	ISR1bits.ISR1_6          	/* bit 6 */
#define ISR1_7         	ISR1bits.ISR1_7          	/* bit 7 */

// ----- ISR2 Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char ISR2_0:1;
		unsigned char ISR2_1:1;
		unsigned char ISR2_2:1;
		unsigned char ISR2_3:1;	
		unsigned char ISR2_4:1;
		unsigned char ISR2_5:1;
		unsigned char ISR2_6:1;
		unsigned char ISR2_7:1;		
	};
} __ISR2bits_t;
extern volatile __ISR2bits_t __at(ISR2_ADDR) ISR2bits;

#define ISR2_0         	ISR2bits.ISR2_0   		/* bit 0 */
#define ISR2_1         	ISR2bits.ISR2_1     		/* bit 1 */
#define ISR2_2         	ISR2bits.ISR2_2          	/* bit 2 */
#define ISR2_3         	ISR2bits.ISR2_3          	/* bit 3 */
#define ISR2_4         	ISR2bits.ISR2_4   		/* bit 4 */
#define ISR2_5         	ISR2bits.ISR2_5     		/* bit 5 */
#define ISR2_6         	ISR2bits.ISR2_6          	/* bit 6 */
#define ISR2_7         	ISR2bits.ISR2_7          	/* bit 7 */

// ----- WECR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char WECR_0:1;
		unsigned char WECR_1:1;
		unsigned char WECR_2:1;
		unsigned char WECR_3:1;	
		unsigned char WECR_4:1;
		unsigned char WECR_5:1;
		unsigned char WECR_6:1;
		unsigned char WECR_7:1;		
	};
} __WECRbits_t;
extern volatile __WECRbits_t __at(WECR_ADDR) WECRbits;

#define WECR_0         	WECRbits.WECR_0   		/* bit 0 */
#define WECR_1         	WECRbits.WECR_1     		/* bit 1 */
#define WECR_2         	WECRbits.WECR_2          	/* bit 2 */
#define WECR_3         	WECRbits.WECR_3          	/* bit 3 */
#define WECR_4         	WECRbits.WECR_4   		/* bit 4 */
#define WECR_5         	WECRbits.WECR_5     		/* bit 5 */
#define WECR_6         	WECRbits.WECR_6          	/* bit 6 */
#define WECR_7         	WECRbits.WECR_7          	/* bit 7 */

// ----- EEPCON Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char EEPCON_0:1;
		unsigned char EEPCON_1:1;
		unsigned char EEPCON_2:1;
		unsigned char EEPCON_3:1;	
		unsigned char EEPCON_4:1;
		unsigned char EEPCON_5:1;
		unsigned char EEPCON_6:1;
		unsigned char EEPCON_7:1;		
	};
} __EEPCONbits_t;
extern volatile __EEPCONbits_t __at(EEPCON_ADDR) EEPCONbits;

#define EEPCON_0         EEPCONbits.EEPCON_0   		/* bit 0 */
#define EEPCON_1         EEPCONbits.EEPCON_1     	/* bit 1 */
#define EEPCON_2         EEPCONbits.EEPCON_2          	/* bit 2 */
#define EEPCON_3         EEPCONbits.EEPCON_3          	/* bit 3 */
#define EEPCON_4         EEPCONbits.EEPCON_4   		/* bit 4 */
#define EEPCON_5         EEPCONbits.EEPCON_5     	/* bit 5 */
#define EEPCON_6         EEPCONbits.EEPCON_6          	/* bit 6 */
#define EEPCON_7         EEPCONbits.EEPCON_7          	/* bit 7 */

// ----- EEPDAT Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char EEPDAT_0:1;
		unsigned char EEPDAT_1:1;
		unsigned char EEPDAT_2:1;
		unsigned char EEPDAT_3:1;	
		unsigned char EEPDAT_4:1;
		unsigned char EEPDAT_5:1;
		unsigned char EEPDAT_6:1;
		unsigned char EEPDAT_7:1;		
	};
} __EEPDATbits_t;
extern volatile __EEPDATbits_t __at(EEPDAT_ADDR) EEPDATbits;

#define EEPDAT_0         EEPDATbits.EEPDAT_0   		/* bit 0 */
#define EEPDAT_1         EEPDATbits.EEPDAT_1     	/* bit 1 */
#define EEPDAT_2         EEPDATbits.EEPDAT_2          	/* bit 2 */
#define EEPDAT_3         EEPDATbits.EEPDAT_3          	/* bit 3 */
#define EEPDAT_4         EEPDATbits.EEPDAT_4   		/* bit 4 */
#define EEPDAT_5         EEPDATbits.EEPDAT_5     	/* bit 5 */
#define EEPDAT_6         EEPDATbits.EEPDAT_6          	/* bit 6 */
#define EEPDAT_7         EEPDATbits.EEPDAT_7          	/* bit 7 */

// ----- IAR Bits --------------------------------------------------------
typedef union {
	struct {
		unsigned char IAR_0:1;
		unsigned char IAR_1:1;
		unsigned char IAR_2:1;
		unsigned char IAR_3:1;	
		unsigned char IAR_4:1;
		unsigned char IAR_5:1;
		unsigned char IAR_6:1;
		unsigned char IAR_7:1;		
	};
} __IARbits_t;
extern volatile __IARbits_t __at(IAR_ADDR) IARbits;

#define IAR_0         	IARbits.IAR_0   		/* bit 0 */
#define IAR_1         	IARbits.IAR_1     		/* bit 1 */
#define IAR_2         	IARbits.IAR_2          		/* bit 2 */
#define IAR_3         	IARbits.IAR_3          		/* bit 3 */
#define IAR_4         	IARbits.IAR_4   		/* bit 4 */
#define IAR_5         	IARbits.IAR_5     		/* bit 5 */
#define IAR_6         	IARbits.IAR_6          		/* bit 6 */
#define IAR_7         	IARbits.IAR_7          		/* bit 7 */

#endif